diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ctrl-headers.cc ns-3.34/src/wifi/model/ctrl-headers.cc
--- ns-3.33/src/wifi/model/ctrl-headers.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ctrl-headers.cc	2021-07-14 10:31:07.000000000 -0700
@@ -19,6 +19,11 @@
  */
 
 #include "ctrl-headers.h"
+#include "wifi-tx-vector.h"
+#include "ns3/he-phy.h"
+#include "wifi-utils.h"
+#include "ns3/address-utils.h"
+#include <algorithm>
 
 namespace ns3 {
 
@@ -31,7 +36,7 @@
 
 CtrlBAckRequestHeader::CtrlBAckRequestHeader ()
   : m_barAckPolicy (false),
-    m_baType (BASIC_BLOCK_ACK)
+    m_barType (BlockAckReqType::BASIC)
 {
 }
 
@@ -67,14 +72,14 @@
 {
   uint32_t size = 0;
   size += 2; //Bar control
-  switch (m_baType)
+  switch (m_barType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckReqType::BASIC:
+      case BlockAckReqType::COMPRESSED:
+      case BlockAckReqType::EXTENDED_COMPRESSED:
         size += 2;
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckReqType::MULTI_TID:
         size += (2 + 2) * (m_tidInfo + 1);
         break;
       default:
@@ -89,14 +94,14 @@
 {
   Buffer::Iterator i = start;
   i.WriteHtolsbU16 (GetBarControl ());
-  switch (m_baType)
+  switch (m_barType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckReqType::BASIC:
+      case BlockAckReqType::COMPRESSED:
+      case BlockAckReqType::EXTENDED_COMPRESSED:
         i.WriteHtolsbU16 (GetStartingSequenceControl ());
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckReqType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -110,14 +115,14 @@
 {
   Buffer::Iterator i = start;
   SetBarControl (i.ReadLsbtohU16 ());
-  switch (m_baType)
+  switch (m_barType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckReqType::BASIC:
+      case BlockAckReqType::COMPRESSED:
+      case BlockAckReqType::EXTENDED_COMPRESSED:
         SetStartingSequenceControl (i.ReadLsbtohU16 ());
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckReqType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -131,17 +136,17 @@
 CtrlBAckRequestHeader::GetBarControl (void) const
 {
   uint16_t res = 0;
-  switch (m_baType)
+  switch (m_barType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
+      case BlockAckReqType::BASIC:
         break;
-      case COMPRESSED_BLOCK_ACK:
+      case BlockAckReqType::COMPRESSED:
         res |= (0x02 << 1);
         break;
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckReqType::EXTENDED_COMPRESSED:
         res |= (0x01 << 1);
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckReqType::MULTI_TID:
         res |= (0x03 << 1);
         break;
       default:
@@ -158,19 +163,19 @@
   m_barAckPolicy = ((bar & 0x01) == 1) ? true : false;
   if (((bar >> 1) & 0x0f) == 0x03)
     {
-      m_baType = MULTI_TID_BLOCK_ACK;
+      m_barType.m_variant = BlockAckReqType::MULTI_TID;
     }
   else if (((bar >> 1) & 0x0f) == 0x01)
     {
-      m_baType = EXTENDED_COMPRESSED_BLOCK_ACK;
+      m_barType.m_variant = BlockAckReqType::EXTENDED_COMPRESSED;
     }
   else if (((bar >> 1) & 0x0f) == 0x02)
     {
-      m_baType = COMPRESSED_BLOCK_ACK;
+      m_barType.m_variant = BlockAckReqType::COMPRESSED;
     }
   else
     {
-      m_baType = BASIC_BLOCK_ACK;
+      m_barType.m_variant = BlockAckReqType::BASIC;
     }
   m_tidInfo = (bar >> 12) & 0x0f;
 }
@@ -194,15 +199,15 @@
 }
 
 void
-CtrlBAckRequestHeader::SetType (BlockAckType type)
+CtrlBAckRequestHeader::SetType (BlockAckReqType type)
 {
-  m_baType = type;
+  m_barType = type;
 }
 
-BlockAckType
+BlockAckReqType
 CtrlBAckRequestHeader::GetType (void) const
 {
-  return m_baType;
+  return m_barType;
 }
 
 void
@@ -239,25 +244,25 @@
 bool
 CtrlBAckRequestHeader::IsBasic (void) const
 {
-  return (m_baType == BASIC_BLOCK_ACK) ? true : false;
+  return (m_barType.m_variant == BlockAckReqType::BASIC) ? true : false;
 }
 
 bool
 CtrlBAckRequestHeader::IsCompressed (void) const
 {
-  return (m_baType == COMPRESSED_BLOCK_ACK) ? true : false;
+  return (m_barType.m_variant == BlockAckReqType::COMPRESSED) ? true : false;
 }
 
 bool
 CtrlBAckRequestHeader::IsExtendedCompressed (void) const
 {
-  return (m_baType == EXTENDED_COMPRESSED_BLOCK_ACK) ? true : false;
+  return (m_barType.m_variant == BlockAckReqType::EXTENDED_COMPRESSED) ? true : false;
 }
 
 bool
 CtrlBAckRequestHeader::IsMultiTid (void) const
 {
-  return (m_baType == MULTI_TID_BLOCK_ACK) ? true : false;
+  return (m_barType.m_variant == BlockAckReqType::MULTI_TID) ? true : false;
 }
 
 
@@ -269,9 +274,9 @@
 
 CtrlBAckResponseHeader::CtrlBAckResponseHeader ()
   : m_baAckPolicy (false),
-    m_baType (BASIC_BLOCK_ACK)
+    m_tidInfo (0)
 {
-  memset (&bitmap, 0, sizeof (bitmap));
+  SetType (BlockAckType::BASIC);
 }
 
 CtrlBAckResponseHeader::~CtrlBAckResponseHeader ()
@@ -298,28 +303,44 @@
 void
 CtrlBAckResponseHeader::Print (std::ostream &os) const
 {
-  os << "TID_INFO=" << m_tidInfo << ", StartingSeq=" << std::hex << m_startingSeq << std::dec;
+  if (m_baType.m_variant != BlockAckType::MULTI_STA)
+    {
+      os << "TID_INFO=" << m_tidInfo << ", StartingSeq=0x" << std::hex << m_baInfo[0].m_startingSeq << std::dec;
+    }
+  else
+    {
+      for (std::size_t i = 0; i < m_baInfo.size (); i++)
+        {
+          os << "{AID=" << GetAid11 (i)
+             << ", TID=" << GetTidInfo (i)
+             << ", StartingSeq=0x" << std::hex << m_baInfo[i].m_startingSeq << std::dec << "}";
+        }
+    }
 }
 
 uint32_t
 CtrlBAckResponseHeader::GetSerializedSize (void) const
 {
+  // This method only makes use of the configured BA type, so that functions like
+  // GetBlockAckSize () can easily return the size of a Block Ack of a given type
   uint32_t size = 0;
-  size += 2; //Bar control
-  switch (m_baType)
+  size += 2; //BA control
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-        size += (2 + 128);
+      case BlockAckType::BASIC:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+        size += (2 + m_baType.m_bitmapLen[0]);
         break;
-      case COMPRESSED_BLOCK_ACK:
-        size += (2 + 8);
-        break;
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-        size += (2 + 32);
-        break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_TID:
         size += (2 + 2 + 8) * (m_tidInfo + 1); //Multi-TID block ack
         break;
+      case BlockAckType::MULTI_STA:
+        for (auto& bitmapLen : m_baType.m_bitmapLen)
+          {
+            size += 2 /* AID TID Info */ + (bitmapLen > 0 ? 2 : 0) /* BA SSC */ + bitmapLen;
+          }
+        break;
       default:
         NS_FATAL_ERROR ("Invalid BA type");
         break;
@@ -332,15 +353,35 @@
 {
   Buffer::Iterator i = start;
   i.WriteHtolsbU16 (GetBaControl ());
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckType::BASIC:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
         i.WriteHtolsbU16 (GetStartingSequenceControl ());
         i = SerializeBitmap (i);
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_STA:
+        for (std::size_t index = 0; index < m_baInfo.size (); index++)
+          {
+            i.WriteHtolsbU16 (m_baInfo[index].m_aidTidInfo);
+            if (GetAid11 (index) != 2045)
+              {
+                if (m_baInfo[index].m_bitmap.size () > 0)
+                  {
+                    i.WriteHtolsbU16 (GetStartingSequenceControl (index));
+                    i = SerializeBitmap (i, index);
+                  }
+              }
+            else
+              {
+                uint32_t reserved = 0;
+                i.WriteHtolsbU32 (reserved);
+                WriteTo (i, m_baInfo[index].m_ra);
+              }
+          }
+        break;
+      case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -354,15 +395,48 @@
 {
   Buffer::Iterator i = start;
   SetBaControl (i.ReadLsbtohU16 ());
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckType::BASIC:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
         SetStartingSequenceControl (i.ReadLsbtohU16 ());
         i = DeserializeBitmap (i);
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_STA:
+        {
+          std::size_t index = 0;
+          while (i.GetRemainingSize () > 0)
+            {
+              m_baInfo.push_back (BaInfoInstance ());
+              m_baType.m_bitmapLen.push_back (0);  // updated by next call to SetStartingSequenceControl
+
+              m_baInfo.back ().m_aidTidInfo = i.ReadLsbtohU16 ();
+
+              if (GetAid11 (index) != 2045)
+                {
+                  // the Block Ack Starting Sequence Control and Block Ack Bitmap subfields
+                  // are only present in Block acknowledgement context, i.e., if the Ack Type
+                  // subfield is set to 0 and the TID subfield is set to a value from 0 to 7.
+                  if (!GetAckType (index) && GetTidInfo (index) < 8)
+                    {
+                      SetStartingSequenceControl (i.ReadLsbtohU16 (), index);
+                      i = DeserializeBitmap (i, index);
+                    }
+                }
+              else
+                {
+                  i.ReadLsbtohU32 ();  // next 4 bytes are reserved
+                  ReadFrom (i, m_baInfo.back ().m_ra);
+                  // the length of this Per AID TID Info subfield is 12, so set
+                  // the bitmap length to 8 to simulate the correct size
+                  m_baType.m_bitmapLen.back () = 8;
+                }
+              index++;
+            }
+        }
+        break;
+      case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -382,6 +456,15 @@
 CtrlBAckResponseHeader::SetType (BlockAckType type)
 {
   m_baType = type;
+  m_baInfo.clear ();
+
+  for (auto& bitmapLen : m_baType.m_bitmapLen)
+    {
+      m_baInfo.push_back ({.m_aidTidInfo = 0,
+                           .m_startingSeq = 0,
+                           .m_bitmap = std::vector<uint8_t> (bitmapLen, 0),
+                           .m_ra = Mac48Address ()});
+    }
 }
 
 BlockAckType
@@ -391,15 +474,30 @@
 }
 
 void
-CtrlBAckResponseHeader::SetTidInfo (uint8_t tid)
+CtrlBAckResponseHeader::SetTidInfo (uint8_t tid, std::size_t index)
 {
-  m_tidInfo = static_cast<uint16_t> (tid);
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  if (m_baType.m_variant != BlockAckType::MULTI_STA)
+    {
+      m_tidInfo = static_cast<uint16_t> (tid);
+    }
+  else
+    {
+      m_baInfo[index].m_aidTidInfo |= ((static_cast<uint16_t> (tid) & 0x000f) << 12);
+    }
 }
 
 void
-CtrlBAckResponseHeader::SetStartingSequence (uint16_t seq)
+CtrlBAckResponseHeader::SetStartingSequence (uint16_t seq, std::size_t index)
 {
-  m_startingSeq = seq;
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  m_baInfo[index].m_startingSeq = seq;
 }
 
 bool
@@ -409,40 +507,138 @@
 }
 
 uint8_t
-CtrlBAckResponseHeader::GetTidInfo (void) const
+CtrlBAckResponseHeader::GetTidInfo (std::size_t index) const
 {
-  uint8_t tid = static_cast<uint8_t> (m_tidInfo);
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  uint8_t tid = 0;
+
+  if (m_baType.m_variant != BlockAckType::MULTI_STA)
+    {
+      tid = static_cast<uint8_t> (m_tidInfo);
+    }
+  else
+    {
+      tid = static_cast<uint8_t> ((m_baInfo[index].m_aidTidInfo >> 12) & 0x000f);
+    }
   return tid;
 }
 
 uint16_t
-CtrlBAckResponseHeader::GetStartingSequence (void) const
+CtrlBAckResponseHeader::GetStartingSequence (std::size_t index) const
 {
-  return m_startingSeq;
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  return m_baInfo[index].m_startingSeq;
 }
 
 bool
 CtrlBAckResponseHeader::IsBasic (void) const
 {
-  return (m_baType == BASIC_BLOCK_ACK) ? true : false;
+  return (m_baType.m_variant == BlockAckType::BASIC) ? true : false;
 }
 
 bool
 CtrlBAckResponseHeader::IsCompressed (void) const
 {
-  return (m_baType == COMPRESSED_BLOCK_ACK) ? true : false;
+  return (m_baType.m_variant == BlockAckType::COMPRESSED) ? true : false;
 }
 
 bool
 CtrlBAckResponseHeader::IsExtendedCompressed (void) const
 {
-  return (m_baType == EXTENDED_COMPRESSED_BLOCK_ACK) ? true : false;
+  return (m_baType.m_variant == BlockAckType::EXTENDED_COMPRESSED) ? true : false;
 }
 
 bool
 CtrlBAckResponseHeader::IsMultiTid (void) const
 {
-  return (m_baType == MULTI_TID_BLOCK_ACK) ? true : false;
+  return (m_baType.m_variant == BlockAckType::MULTI_TID) ? true : false;
+}
+
+bool
+CtrlBAckResponseHeader::IsMultiSta (void) const
+{
+  return (m_baType.m_variant == BlockAckType::MULTI_STA) ? true : false;
+}
+
+void
+CtrlBAckResponseHeader::SetAid11 (uint16_t aid, std::size_t index)
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA && index < m_baInfo.size ());
+
+  m_baInfo[index].m_aidTidInfo |= (aid & 0x07ff);
+}
+
+uint16_t
+CtrlBAckResponseHeader::GetAid11 (std::size_t index) const
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA && index < m_baInfo.size ());
+
+  return m_baInfo[index].m_aidTidInfo & 0x07ff;
+}
+
+void
+CtrlBAckResponseHeader::SetAckType (bool type, std::size_t index)
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA && index < m_baInfo.size ());
+
+  if (type)
+    {
+      m_baInfo[index].m_aidTidInfo |= (1 << 11);
+    }
+}
+
+bool
+CtrlBAckResponseHeader::GetAckType (std::size_t index) const
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA && index < m_baInfo.size ());
+
+  return ((m_baInfo[index].m_aidTidInfo >> 11) & 0x0001) != 0;
+}
+
+void
+CtrlBAckResponseHeader::SetUnassociatedStaAddress (const Mac48Address& ra, std::size_t index)
+{
+  NS_ASSERT (GetAid11 (index) == 2045);
+
+  m_baInfo[index].m_ra = ra;
+}
+
+Mac48Address
+CtrlBAckResponseHeader::GetUnassociatedStaAddress (std::size_t index) const
+{
+  NS_ASSERT (GetAid11 (index) == 2045);
+
+  return m_baInfo[index].m_ra;
+}
+
+std::size_t
+CtrlBAckResponseHeader::GetNPerAidTidInfoSubfields (void) const
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA);
+  return m_baInfo.size ();
+}
+
+std::vector<uint32_t>
+CtrlBAckResponseHeader::FindPerAidTidInfoWithAid (uint16_t aid) const
+{
+  NS_ASSERT (m_baType.m_variant == BlockAckType::MULTI_STA);
+
+  std::vector<uint32_t> ret;
+  ret.reserve (m_baInfo.size ());
+  for (uint32_t i = 0; i < m_baInfo.size (); i++)
+    {
+      if (GetAid11 (i) == aid)
+        {
+          ret.push_back (i);
+        }
+    }
+  return ret;
 }
 
 uint16_t
@@ -453,24 +649,30 @@
     {
       res |= 0x1;
     }
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
+      case BlockAckType::BASIC:
         break;
-      case COMPRESSED_BLOCK_ACK:
+      case BlockAckType::COMPRESSED:
         res |= (0x02 << 1);
         break;
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckType::EXTENDED_COMPRESSED:
         res |= (0x01 << 1);
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_TID:
         res |= (0x03 << 1);
         break;
+      case BlockAckType::MULTI_STA:
+        res |= (0x0b << 1);
+        break;
       default:
         NS_FATAL_ERROR ("Invalid BA type");
         break;
     }
-  res |= (m_tidInfo << 12) & (0xf << 12);
+  if (m_baType.m_variant != BlockAckType::MULTI_STA)
+    {
+      res |= (m_tidInfo << 12) & (0xf << 12);
+    }
   return res;
 }
 
@@ -480,57 +682,158 @@
   m_baAckPolicy = ((ba & 0x01) == 1) ? true : false;
   if (((ba >> 1) & 0x0f) == 0x03)
     {
-      m_baType = MULTI_TID_BLOCK_ACK;
+      SetType (BlockAckType::MULTI_TID);
     }
   else if (((ba >> 1) & 0x0f) == 0x01)
     {
-      m_baType = EXTENDED_COMPRESSED_BLOCK_ACK;
+      SetType (BlockAckType::EXTENDED_COMPRESSED);
     }
   else if (((ba >> 1) & 0x0f) == 0x02)
     {
-      m_baType = COMPRESSED_BLOCK_ACK;
+      SetType (BlockAckType::COMPRESSED);
+    }
+  else if (((ba >> 1) & 0x0f) == 0)
+    {
+      SetType (BlockAckType::BASIC);
+    }
+  else if (((ba >> 1) & 0x0f) == 0x0b)
+    {
+      SetType (BlockAckType::MULTI_STA);
     }
   else
     {
-      m_baType = BASIC_BLOCK_ACK;
+      NS_FATAL_ERROR ("Invalid BA type");
+    }
+  if (m_baType.m_variant != BlockAckType::MULTI_STA)
+    {
+      m_tidInfo = (ba >> 12) & 0x0f;
     }
-  m_tidInfo = (ba >> 12) & 0x0f;
 }
 
 uint16_t
-CtrlBAckResponseHeader::GetStartingSequenceControl (void) const
+CtrlBAckResponseHeader::GetStartingSequenceControl (std::size_t index) const
 {
-  return (m_startingSeq << 4) & 0xfff0;
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  uint16_t ret = (m_baInfo[index].m_startingSeq << 4) & 0xfff0;
+
+  // The Fragment Number subfield encodes the length of the bitmap for
+  // Compressed and Multi-STA variants (see sections 9.3.1.9.3 and 9.3.1.9.7
+  // of 802.11ax Draft 3.0). Note that Fragmentation Level 3 is not supported.
+  if (m_baType.m_variant == BlockAckType::COMPRESSED)
+    {
+      if (m_baType.m_bitmapLen[0] == 32)
+        {
+          ret |= 0x0004;
+        }
+    }
+  else if (m_baType.m_variant == BlockAckType::MULTI_STA)
+    {
+      NS_ASSERT (m_baInfo.size () == m_baType.m_bitmapLen.size ());
+      NS_ASSERT_MSG (m_baInfo[index].m_bitmap.size () > 0,
+                     "This Per AID TID Info subfield has no Starting Sequence Control subfield");
+
+      if (m_baType.m_bitmapLen[index] == 16)
+        {
+          ret |= 0x0002;
+        }
+      else if (m_baType.m_bitmapLen[index] == 32)
+        {
+          ret |= 0x0004;
+        }
+      else if (m_baType.m_bitmapLen[index] == 4)
+        {
+          ret |= 0x0006;
+        }
+    }
+  return ret;
 }
 
 void
-CtrlBAckResponseHeader::SetStartingSequenceControl (uint16_t seqControl)
+CtrlBAckResponseHeader::SetStartingSequenceControl (uint16_t seqControl, std::size_t index)
 {
-  m_startingSeq = (seqControl >> 4) & 0x0fff;
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  // The Fragment Number subfield encodes the length of the bitmap for
+  // Compressed and Multi-STA variants (see sections 9.3.1.9.3 and 9.3.1.9.7
+  // of 802.11ax Draft 3.0). Note that Fragmentation Level 3 is not supported.
+  if (m_baType.m_variant == BlockAckType::COMPRESSED)
+    {
+      if ((seqControl & 0x0001) == 1)
+        {
+          NS_FATAL_ERROR ("Fragmentation Level 3 unsupported");
+        }
+      if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 0)
+        {
+          SetType ({BlockAckType::COMPRESSED, {8}});
+        }
+      else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 2)
+        {
+          SetType ({BlockAckType::COMPRESSED, {32}});
+        }
+      else
+        {
+          NS_FATAL_ERROR ("Reserved configurations");
+        }
+    }
+  else if (m_baType.m_variant == BlockAckType::MULTI_STA)
+    {
+      if ((seqControl & 0x0001) == 1)
+        {
+          NS_FATAL_ERROR ("Fragmentation Level 3 unsupported");
+        }
+      uint8_t bitmapLen = 0;
+      if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 0)
+        {
+          bitmapLen = 8;
+        }
+      else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 1)
+        {
+          bitmapLen = 16;
+        }
+      else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 2)
+        {
+          bitmapLen = 32;
+        }
+      else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 3)
+        {
+          bitmapLen = 4;
+        }
+      else
+        {
+          NS_FATAL_ERROR ("Reserved configurations");
+        }
+      m_baType.m_bitmapLen[index] = bitmapLen;
+      m_baInfo[index].m_bitmap.assign (bitmapLen, 0);
+    }
+
+  m_baInfo[index].m_startingSeq = (seqControl >> 4) & 0x0fff;
 }
 
 Buffer::Iterator
-CtrlBAckResponseHeader::SerializeBitmap (Buffer::Iterator start) const
+CtrlBAckResponseHeader::SerializeBitmap (Buffer::Iterator start, std::size_t index) const
 {
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
   Buffer::Iterator i = start;
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-          for (uint8_t j = 0; j < 64; j++)
+      case BlockAckType::BASIC:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
+          for (const auto& byte : m_baInfo[index].m_bitmap)
             {
-              i.WriteHtolsbU16 (bitmap.m_bitmap[j]);
+              i.WriteU8 (byte);
             }
           break;
-      case COMPRESSED_BLOCK_ACK:
-          i.WriteHtolsbU64 (bitmap.m_compressedBitmap);
-          break;
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-          i.WriteHtolsbU64 (bitmap.m_extendedCompressedBitmap[0]);
-          i.WriteHtolsbU64 (bitmap.m_extendedCompressedBitmap[1]);
-          i.WriteHtolsbU64 (bitmap.m_extendedCompressedBitmap[2]);
-          i.WriteHtolsbU64 (bitmap.m_extendedCompressedBitmap[3]);
-          break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -541,27 +844,25 @@
 }
 
 Buffer::Iterator
-CtrlBAckResponseHeader::DeserializeBitmap (Buffer::Iterator start)
+CtrlBAckResponseHeader::DeserializeBitmap (Buffer::Iterator start, std::size_t index)
 {
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
   Buffer::Iterator i = start;
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-          for (uint8_t j = 0; j < 64; j++)
+      case BlockAckType::BASIC:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
+          for (uint8_t j = 0; j < m_baType.m_bitmapLen[index]; j++)
             {
-              bitmap.m_bitmap[j] = i.ReadLsbtohU16 ();
+              m_baInfo[index].m_bitmap[j] = i.ReadU8 ();
             }
           break;
-      case COMPRESSED_BLOCK_ACK:
-          bitmap.m_compressedBitmap = i.ReadLsbtohU64 ();
-          break;
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-          bitmap.m_extendedCompressedBitmap[0] = i.ReadLsbtohU64 ();
-          bitmap.m_extendedCompressedBitmap[1] = i.ReadLsbtohU64 ();
-          bitmap.m_extendedCompressedBitmap[2] = i.ReadLsbtohU64 ();
-          bitmap.m_extendedCompressedBitmap[3] = i.ReadLsbtohU64 ();
-          break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -572,42 +873,37 @@
 }
 
 void
-CtrlBAckResponseHeader::SetReceivedPacket (uint16_t seq)
+CtrlBAckResponseHeader::SetReceivedPacket (uint16_t seq, std::size_t index)
 {
-  if (!IsInBitmap (seq))
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  if (!IsInBitmap (seq, index))
     {
       return;
     }
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-        {
-          /* To set correctly basic block ack bitmap we need fragment number too.
-             So if it's not specified, we consider packet not fragmented. */
-          bitmap.m_bitmap[IndexInBitmap (seq)] |= 0x0001;
-          break;
-        }
-      case COMPRESSED_BLOCK_ACK:
-        {
-          bitmap.m_compressedBitmap |= (uint64_t (0x0000000000000001) << IndexInBitmap (seq));
-          break;
-        }
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-        {
-          uint16_t index = IndexInBitmap (seq);
-          bitmap.m_extendedCompressedBitmap[index/64] |= (uint64_t (0x0000000000000001) << index);
-          break;
-        }
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::BASIC:
+        /* To set correctly basic block ack bitmap we need fragment number too.
+            So if it's not specified, we consider packet not fragmented. */
+        m_baInfo[index].m_bitmap[IndexInBitmap (seq) * 2] |= 0x01;
+        break;
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
         {
-          NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
+          uint16_t i = IndexInBitmap (seq, index);
+          m_baInfo[index].m_bitmap[i / 8] |= (uint8_t (0x01) << (i % 8));
           break;
         }
+      case BlockAckType::MULTI_TID:
+        NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
+        break;
       default:
-        {
-          NS_FATAL_ERROR ("Invalid BA type");
-          break;
-        }
+        NS_FATAL_ERROR ("Invalid BA type");
+        break;
     }
 }
 
@@ -619,17 +915,18 @@
     {
       return;
     }
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-        bitmap.m_bitmap[IndexInBitmap (seq)] |= (0x0001 << frag);
+      case BlockAckType::BASIC:
+        m_baInfo[0].m_bitmap[IndexInBitmap (seq) * 2 + frag / 8] |= (0x01 << (frag % 8));
         break;
-      case COMPRESSED_BLOCK_ACK:
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
         /* We can ignore this...compressed block ack doesn't support
            acknowledgment of single fragments */
         break;
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
         break;
       default:
@@ -639,43 +936,41 @@
 }
 
 bool
-CtrlBAckResponseHeader::IsPacketReceived (uint16_t seq) const
+CtrlBAckResponseHeader::IsPacketReceived (uint16_t seq, std::size_t index) const
 {
-  if (!IsInBitmap (seq))
+  NS_ASSERT_MSG (m_baType.m_variant == BlockAckType::MULTI_STA || index == 0,
+                 "index can only be non null for Multi-STA Block Ack");
+  NS_ASSERT (index < m_baInfo.size ());
+
+  if (m_baType.m_variant == BlockAckType::MULTI_STA
+      && GetAckType (index) && GetTidInfo (index) == 14)
+    {
+      // All-ack context
+      return true;
+    }
+  if (!IsInBitmap (seq, index))
     {
       return false;
     }
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-        {
-          /*It's impossible to say if an entire packet was correctly received. */
-          return false;
-        }
-      case COMPRESSED_BLOCK_ACK:
+      case BlockAckType::BASIC:
+        /*It's impossible to say if an entire packet was correctly received. */
+        return false;
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
         {
-          /* Although this could make no sense, if packet with sequence number
-             equal to <i>seq</i> was correctly received, also all of its fragments
-             were correctly received. */
-          uint64_t mask = uint64_t (0x0000000000000001);
-          return (((bitmap.m_compressedBitmap >> IndexInBitmap (seq)) & mask) == 1) ? true : false;
-        }
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-        {
-          uint64_t mask = uint64_t (0x0000000000000001);
-          uint16_t index = IndexInBitmap (seq);
-          return (((bitmap.m_extendedCompressedBitmap[index/64] >> index) & mask) == 1) ? true : false;
-        }
-      case MULTI_TID_BLOCK_ACK:
-        {
-          NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
-          break;
+          uint16_t i = IndexInBitmap (seq, index);
+          uint8_t mask = uint8_t (0x01) << (i % 8);
+          return ((m_baInfo[index].m_bitmap[i / 8] & mask) != 0) ? true : false;
         }
+      case BlockAckType::MULTI_TID:
+        NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
+        break;
       default:
-        {
-          NS_FATAL_ERROR ("Invalid BA type");
-          break;
-        }
+        NS_FATAL_ERROR ("Invalid BA type");
+        break;
     }
   return false;
 }
@@ -688,27 +983,17 @@
     {
       return false;
     }
-  switch (m_baType)
+  switch (m_baType.m_variant)
     {
-      case BASIC_BLOCK_ACK:
-        {
-          return ((bitmap.m_bitmap[IndexInBitmap (seq)] & (0x0001 << frag)) != 0x0000) ? true : false;
-        }
-      case COMPRESSED_BLOCK_ACK:
-        {
-          /* Although this could make no sense, if packet with sequence number
-             equal to <i>seq</i> was correctly received, also all of its fragments
-             were correctly received. */
-          uint64_t mask = uint64_t (0x0000000000000001);
-          return (((bitmap.m_compressedBitmap >> IndexInBitmap (seq)) & mask) == 1) ? true : false;
-        }
-      case EXTENDED_COMPRESSED_BLOCK_ACK:
-        {
-          uint64_t mask = uint64_t (0x0000000000000001);
-          uint16_t index = IndexInBitmap (seq);
-          return (((bitmap.m_extendedCompressedBitmap[index/64] >> index) & mask) == 1) ? true : false;
-        }
-      case MULTI_TID_BLOCK_ACK:
+      case BlockAckType::BASIC:
+        return ((m_baInfo[0].m_bitmap[IndexInBitmap (seq) * 2 + frag / 8] & (0x01 << (frag % 8))) != 0) ? true : false;
+      case BlockAckType::COMPRESSED:
+      case BlockAckType::EXTENDED_COMPRESSED:
+      case BlockAckType::MULTI_STA:
+        /* We can ignore this...compressed block ack doesn't support
+           acknowledgement of single fragments */
+        return false;
+      case BlockAckType::MULTI_TID:
         {
           NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
           break;
